module Hover
  module Encoder
    class JSONStream
      attr_accessor :file

      def initialize
      end

      def open(path)
        self.file = File.open(path, 'w')
      end

      def close
        self.file.close
        self.file = nil
      end

      def append(attributes, klass)
        self.file.puts(JSON.dump(attributes.merge('class' => klass.name)))
      end

      def append_each(attributes_sets, klass)
        attributes_sets.each do |attributes|
          append(attributes, klass)
        end
      end

      def append_records(scope)
        scope.find_each do |record|
          append(record.attributes.as_json, record.class)
        end
      end
    end
  end
end